<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { inject, ref } from 'vue';
import { useI18n } from 'vue-i18n';
import { storeToRefs } from 'pinia';
import { useCreateStore } from '@/stores/create';
import BoxSelector from "@/components/general/form/BoxSelector.vue";
import { itemEnum } from '@/enums/enums';
import ColorSwatch from "@/components/general/form/ColorSwatch.vue";
import Button from '@/components/general/Button.vue';


const { t } = useI18n();
const $t = t;

const createStore = useCreateStore();
const { backgroundColor, elementColor, commentColor, activePage, type, elementShape, fontSize, font } = storeToRefs(createStore);
let configuration = inject<any>('configuration');
const backgroundColors = configuration.style.backgroundColors;
const elementColors = configuration.style.shapeColors;
const commentColors = configuration.style.commentColors;

const shapeColorLabel = ref(type.value === 'Freeform' || type.value === 'Timeline' ? $t('create.color.element') : $t('create.color.column'));
const commentColorLabel = ref(type.value === 'Freeform' || type.value === 'Timeline' ? $t('create.color.comment') : $t('create.color.element') + " / " + $t('create.color.comment'));
const shapeColorLabelExample = ref(type.value === 'Freeform' || type.value === 'Timeline' ? $t('example.element') : $t('example.column'));
const commentColorLabelExample = ref(type.value === 'Freeform' || type.value === 'Timeline' ? $t('example.comment') : $t('example.element') + "/" + $t('example.comment'));

const setActivePage = (value: string) => {
    activePage.value = value;
}

</script>
<template>
    <div class="flex flex-col justify-between h-full">
        <div class="flex flex-row w-full">
            <div class="sm:w-3/5">
                <div class="px-4">
                    <BoxSelector :label="$t('adjustPanel.general.background.color')" v-model="backgroundColor"
                        :items="backgroundColors" :identifier="itemEnum.VALUE" type="colors" />
                    <ColorSwatch v-model="backgroundColor" />
                    <BoxSelector :label="shapeColorLabel" v-model="elementColor" :items="elementColors"
                        :identifier="itemEnum.VALUE" type="colors" />
                    <ColorSwatch v-model="elementColor" />
                    <BoxSelector :label="commentColorLabel" v-model="commentColor" :items="commentColors"
                        :identifier="itemEnum.VALUE" type="colors" />
                    <ColorSwatch v-model="commentColor" />
                </div>
            </div>
            <div class="sm:w-2/5 p-4 pt-0 h-[330px] w-full">
                <h5 class="text-center mb-4 text-xl">{{ $t('create.preview') }}</h5>
                <div :class="['w-full relative box-border transition duration-100 ease-in-out rounded-lg h-52 flex flex-col gap-8', font]"
                    :style="{ background: backgroundColor }">
                    <div class="border border-black h-20 p-4 relative box-border transition duration-100 ease-in-out rounded-lg bg-white text-gray-500 shadow-md mx-auto w-full"
                        :class="[elementShape, fontSize]" :style="{ background: elementColor }">
                        <span>{{ shapeColorLabelExample }}</span>
                    </div>
                    <div class="border border-black h-20 p-4 relative box-border transition duration-100 ease-in-out rounded-lg bg-white text-gray-500 shadow-md mx-auto w-full"
                        :class="[elementShape, fontSize]" :style="{ background: commentColor }">
                        <span>{{ commentColorLabelExample }}</span>
                    </div>
                </div>
            </div>
        </div>
        <div class="flex flex-row w-full justify-between">
            <div>
                <Button variant="cancel" @click="setActivePage('style')">
                    <i class="ri-arrow-left-s-line"></i>
                    <span class="uppercase">{{ $t('general.buttons.back') }}</span>
                </Button>
            </div>
            <div>
                <Button variant="confirm" @click="setActivePage(type.toLowerCase() === 'freeform' || type.toLowerCase() === 'timeline' ? 'line' : 'preview')">
                    <span class="uppercase">{{ $t('general.buttons.next') }}</span>
                    <i class="ri-arrow-right-s-line"></i>
                </Button>
            </div>
        </div>
    </div>
</template>